module DeviseAuthentication::Base
    extend ActiveSupport::Concern
    included do
        # rescue_from CanCan::AccessDenied, :with => :user_not_authorized
        # rescue_from AuthenticationError, :with => :user_not_authorized

        # Check Authentication before every action
        before_action :check_auth
    end

    def check_auth
        # The extended class might have the check_auth method implemented. We want to
        # keep it in the game..
        super if defined?(super)

        # Check whether authenticated
        authenticate_user!
    end
end
